package FJsc;

import java.util.*;
import FJsc.typechecker.*;
import FJsc.typechecker.typeassum.*;

public class Selector{

    public static Set select(Context ctx,Env ce,boolean verbose){
	HashSet hs=new HashSet(); // the result
	HashMap sources=ctx.getSources(),binaries=ctx.getBinaries();
	Iterator it=sources.keySet().iterator();
	String className;
	LocEnv le;
	while(it.hasNext()){
	    className=(String)it.next();
	    if(binaries.containsKey(className)){
		le=((BinaryClassDec)binaries.get(className)).getLocEnv();
		if(verbose)
		    System.out.println(className+"\n"+le);
		if(le==null || !le.entailedBy(ce))
		    hs.add(className);
	    }
	    else
		hs.add(className);
	}
	return hs;
    }
    
}
