package FJsc.typechecker;

import java.io.IOException;
import FJsc.typechecker.typeassum.LocEnv;
import FJsc.typechecker.typeassum.SubtypeAssum;
import org.apache.bcel.generic.Type;

public class AssignExp extends Exp{

    protected Variable var;
    protected Exp exp;

    public AssignExp(Variable var,Exp exp){
	this.var=var;
	this.exp=exp;
    } 

    public Type typecheck(Env ce,Env ve,LocEnv le)throws TypecheckerException,IOException{
	Type t1=var.typecheck(ce,ve,le);
	Type t2=exp.typecheck(ce,ve,le);
	le.add(new SubtypeAssum(ce,t2,t1));
	return t1;
    }

}

