package FJsc.typechecker;

import java.io.IOException;
import FJsc.typechecker.typeassum.LocEnv;
import FJsc.typechecker.typeassum.ComparableAssum;
import org.apache.bcel.generic.Type;

public class CastExp extends Exp{

    protected Type type;
    protected Exp exp;

    public CastExp(Type type,Exp exp){
	this.type=type;
	this.exp=exp;
    } 

    public Type typecheck(Env ce,Env ve,LocEnv le)throws TypecheckerException,IOException{
	Type t=exp.typecheck(ce,ve,le);
	le.add(new ComparableAssum(ce,type,t));
	return type;
    }

}

