package FJsc.typechecker;

import java.io.IOException;
import FJsc.typechecker.typeassum.LocEnv;
import FJsc.typechecker.typeassum.FieldAssum;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;

public class FieldExp extends Variable{

    protected Exp target;
    protected String fieldName;

    public FieldExp(Exp target,String fieldName){
	this.target=target;
	this.fieldName=fieldName;
    } 

    public Type typecheck(Env ce,Env ve,LocEnv le)throws TypecheckerException,IOException{
	ObjectType tg;
	try{
	    tg=(ObjectType) target.typecheck(ce,ve,le);
	}
	catch(ClassCastException e){
	    throw new TypecheckerException("Expecting a reference type");
	}
	FieldAssum fa=new FieldAssum(ce,tg,fieldName);
	le.add(fa);
	return fa.getType();
    }

}

