package FJsc.typechecker;

import java.util.Iterator;

public class MethSig extends Types{

    protected String name;

    public MethSig(String name){
    	this.name=name;
    }

    public MethSig(String name,Types types){
    	this(name);
	Iterator it=types.iterator();
	while(it.hasNext())
	    addLast(it.next());
    }

    public String getName(){
	return name;
    }

    public boolean equals(Object o){
	try{
	    return equals((MethSig) o);
	}
	catch(ClassCastException e){
	    return false;
	}
    }

    public boolean equals(MethSig ms){
	return ms!=null && name.equals(ms.name) && super.equals(ms);
    }

    public int hashCode(){
	return name.hashCode()+super.hashCode();
    }

    public String toString(){
	return name.toString()+super.toString();
    }

}
