package FJsc.typechecker;

import java.io.IOException;
import FJsc.typechecker.typeassum.*;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;

public class NewExp extends Exp{

    protected String className;
    protected Exps args;

    public NewExp(String className,Exps args){
	this.className=className;
	this.args=args;
    }

    public Type typecheck(Env ce,Env ve,LocEnv le)throws TypecheckerException,IOException{
	Types ts=args.typecheck(ce,ve,le);
	le.add(new ConsAssum(ce,className,ts));
	return new ObjectType(className);
    }

}
