package FJsc.typechecker;

import java.io.IOException;
import FJsc.typechecker.typeassum.LocEnv;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;

public class StrictLocalVariableExp extends Variable{ // cannot be converted into a type because of nested pars 

    protected String str;

    public StrictLocalVariableExp(String str){
	this.str=str;
    }

    public Type typecheck(Env ce,Env ve,LocEnv le)throws TypecheckerException{
	Type res=(Type) ve.get(str);
	if(res==null)
	    throw new TypecheckerException("Undeclared variable "+str);
	return res;
    }

}
