package FJsc.typechecker.typeassum;

import java.io.*;
import java.util.*;
import FJsc.typechecker.*;
import org.apache.bcel.generic.Type;


public abstract class TypeAssum implements Serializable{

    public abstract void entailedBy(Env ce)throws TypecheckerException;

    public boolean alwaysHolds(){return false;} // pessimistic vision!

    static boolean subtypeOf(Env ce,Types ts1,Types ts2){
	Iterator it1=ts1.iterator(),it2=ts2.iterator();
	Type t1,t2;
	while(it1.hasNext()&&it2.hasNext()){
	    t1=(Type)it1.next();
	    t2=(Type)it2.next();
	    try{
		new SubtypeAssum(t1,t2).entailedBy(ce);
	    }
	    catch(TypecheckerException e){return false;}
	}
	return(!it1.hasNext()&&!it2.hasNext());
    }

    static Types mostSpecific(Env ce,List l)throws NoMostSpecificException{
	ListIterator it1=l.listIterator(0),it2; 
	Types ts1,ts2;
	while(it1.hasNext()){
	    ts1=(Types)it1.next();
	    it2=l.listIterator(it1.nextIndex());
	    while(it2.hasNext()){
		ts2=(Types)it2.next();
		if(subtypeOf(ce,ts2,ts1))
		    it1.remove();
		else if(subtypeOf(ce,ts1,ts2))
		    it2.remove();
	    }
	}
	if(l.size()==1)
	    return (Types) l.iterator().next(); 
	throw new NoMostSpecificException();
    } 

}
