package FJsc.typechecker;

import java.io.IOException;
import java.util.ListIterator;
import FJsc.typechecker.typeassum.*;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;

public class ConsDec{

    protected Params params;
    protected AssignExps body;

    public ConsDec(Params params,AssignExps body){
	this.params=params;
	this.body=body;
    }

    public Params getParams(){
	return params;
    }

    public AssignExps getBody(){
	return body;
    }
    
    public void typecheck(Env ce,String className,LocEnv le)throws TypecheckerException,IOException{
	Env ve=new Env();
	ve.put("this",new ObjectType(className));
	Param p;
	Type t;
	ListIterator it=params.listIterator(0);
	while(it.hasNext()){
	    p=(Param)it.next();
	    t=p.getType();
	    ve.put(p.getName(),t);
	}
	le.add(new ConsAssum(ce,ce.getSuperclass(className),new Types()));// implicit invocation of the superclass constructor
	body.typecheck(ce,ve,le);
    }

}
