package FJsc.typechecker;

import java.io.IOException;
import java.util.ListIterator;
import FJsc.typechecker.typeassum.*;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.ObjectType;

public class MethDec{

    protected Type type;
    protected String name;
    protected Params params;
    protected Exp body;

    public MethDec(Type type,String name,Params params,Exp body){
	this.type=type;
	this.name=name;
	this.params=params;
	this.body=body;
    }

    public Type getType(){
	return type;
    }

    public String getName(){
	return name;
    }

    public Params getParams(){
	return params;
    }

    public Exp getBody(){
	return body;
    }

    public void typecheck(Env ce,String className,LocEnv le)throws TypecheckerException,IOException{
	Env ve=new Env();
	ve.put("this",new ObjectType(className));
	Param p;
	Type t;
	ListIterator it=params.listIterator(0);
	while(it.hasNext()){
	    p=(Param)it.next();
	    t=p.getType();
	    ve.put(p.getName(),t);
	}
	Type type2=body.typecheck(ce,ve,le);
	le.add(new SubtypeAssum(ce,type2,type));
    }

}
