package FJsc.typechecker.typeassum;

import java.io.*;
import java.util.*;
import FJsc.typechecker.*;
import org.apache.bcel.generic.Type;

public class ComparableAssum extends SubtypeAssum{

    private void swap(){
	Type tmp=t1;
	t1=t2;
	t2=tmp;
    }

    public ComparableAssum(Type t1,Type t2){
	super(t1,t2);
    }

    public ComparableAssum(Env ce,Type t1,Type t2)throws TypecheckerException{
	super(ce,t1,t2);
    }

    public boolean alwaysHolds(){
	if(super.alwaysHolds())
	    return true;
	swap();
	boolean b=super.alwaysHolds();
	swap();
	return b;
    }

    public void entailedBy(Env ce)throws TypecheckerException{
        try{
	    super.entailedBy(ce);
	    return;
	}
	catch(UndefClassException e){throw e;}
	catch(TypecheckerException e){}
	swap();
        try{
	    super.entailedBy(ce);
	    return;
	}
	catch(UndefClassException e){throw e;}
	catch(TypecheckerException e){
	    throw new TypecheckerException(t1+" is not comparable with "+t2);
	}
	finally{
	    swap();
	}
    }

    public String toString(){
	return t1+" ~ "+t2;
    }

    public boolean equals(Object o){
	try{
	    return equals((ComparableAssum) o);
	}
	catch(ClassCastException e){
	    return false;
	}
    }

    public boolean equals(ComparableAssum ca){
	return super.equals(ca);
    }

}
